package com.gxwebsoft.tower.controller;

import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.tower.entity.TowerProject;
import com.gxwebsoft.tower.entity.TowerProjectOrder;
import com.gxwebsoft.tower.entity.TowerProjectPlace;
import com.gxwebsoft.tower.entity.TowerProjectUser;
import com.gxwebsoft.tower.param.TowerProjectParam;
import com.gxwebsoft.tower.service.TowerProjectOrderService;
import com.gxwebsoft.tower.service.TowerProjectPlaceService;
import com.gxwebsoft.tower.service.TowerProjectService;
import com.gxwebsoft.tower.service.TowerProjectUserService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;
import java.util.Set;

/**
 * 项目管理控制器
 *
 * @author 科技小王子
 * @since 2023-05-22 13:30:39
 */
@Api(tags = "项目管理管理")
@RestController
@RequestMapping("/api/tower/tower-project")
public class TowerProjectController extends BaseController {
    @Resource
    private TowerProjectService towerProjectService;
    @Resource
    private TowerProjectOrderService towerProjectOrderService;
    @Resource
    private TowerProjectUserService towerProjectUserService;
    @Resource
    private TowerProjectPlaceService towerProjectPlaceService;

    @PreAuthorize("hasAuthority('tower:towerProject:list')")
    @ApiOperation("分页查询项目管理")
    @GetMapping("/page")
    public ApiResult<PageResult<TowerProject>> page(TowerProjectParam param) {
        // 使用关联查询
        return success(towerProjectService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('tower:towerProject:list')")
    @ApiOperation("查询全部项目管理")
    @GetMapping()
    public ApiResult<List<TowerProject>> list(TowerProjectParam param) {
        // 使用关联查询
        return success(towerProjectService.listRel(param));
    }

    @PreAuthorize("hasAuthority('tower:towerProject:list')")
    @ApiOperation("根据id查询项目管理")
    @GetMapping("/{id}")
    public ApiResult<TowerProject> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(towerProjectService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('tower:towerProject:save')")
    @Transactional(rollbackFor = {Exception.class})
    @ApiOperation("添加项目管理")
    @PostMapping()
    public ApiResult<?> save(@RequestBody TowerProject towerProject) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
          towerProject.setUserId(loginUser.getUserId());
        }
      System.out.println("towerProject = " + towerProject.getPlaces2());
        if (towerProjectService.save(towerProject)) {
          final Integer projectId = towerProject.getProjectId();
            // 批量添加项目成员
            if (!towerProject.getUsers().isEmpty()) {
              final Set<TowerProjectUser> users = towerProject.getUsers();
              users.forEach(d->{
                d.setProjectId(projectId);
              });
              towerProjectUserService.saveBatch(users);
            }
            // 批量添加项目订单
            if (!towerProject.getOrders().isEmpty()) {
              final Set<TowerProjectOrder> orders = towerProject.getOrders();
              orders.forEach(d->{
                d.setProjectId(projectId);
              });
              towerProjectOrderService.saveBatch(orders);
            }
            // 批量添加检查部位配置
            if (!towerProject.getPlaces1().isEmpty()) {
              final Set<TowerProjectPlace> places1 = towerProject.getPlaces1();
              places1.forEach(d->{
                d.setProjectId(projectId);
              });
              towerProjectPlaceService.saveBatch(places1);
            }
            // 批量添加保养部位配置
            if (!towerProject.getPlaces2().isEmpty()) {
              final Set<TowerProjectPlace> places2 = towerProject.getPlaces2();
              places2.forEach(d->{
                d.setProjectId(projectId);
              });
              towerProjectPlaceService.saveBatch(places2);
            }
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('tower:towerProject:update')")
    @Transactional(rollbackFor = {Exception.class})
    @ApiOperation("修改项目管理")
    @PutMapping()
    public ApiResult<?> update(@RequestBody TowerProject towerProject) {
        if (towerProjectService.updateById(towerProject)) {
            // 批量修改项目成员
            towerProjectUserService.saveOrUpdateBatch(towerProject.getUsers());
            // 批量修改项目订单
            towerProjectOrderService.saveOrUpdateBatch(towerProject.getOrders());
            // 批量修改检查/保养部位配置
            towerProjectPlaceService.saveOrUpdateBatch(towerProject.getPlaces1());
            towerProjectPlaceService.saveOrUpdateBatch(towerProject.getPlaces2());
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('tower:towerProject:remove')")
    @ApiOperation("删除项目管理")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (towerProjectService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('tower:towerProject:save')")
    @ApiOperation("批量添加项目管理")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<TowerProject> list) {
        if (towerProjectService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('tower:towerProject:update')")
    @ApiOperation("批量修改项目管理")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<TowerProject> batchParam) {
        if (batchParam.update(towerProjectService, "project_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('tower:towerProject:remove')")
    @OperationLog
    @ApiOperation("批量删除项目管理")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (towerProjectService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
